# std::is_final

From cppreference.com
< cpp‎ | types

Defined in header `<type_traits>` |  |
template< class T > struct is_final; |  | (since C++14)

If `T` is a final class (that is, a class declared with the final specifier), provides the member constant `value` equal true. For any other type, `value` is false.

If `T` is a class type, `T` shall be a complete type; otherwise, the behavior is undefined.

### Template parameters

T | - | a type to check

### Helper variable template

template< class T > inline constexpr bool is_final_v = is_final<T>::value; |  | (since C++17)

## Inherited from std::integral_constant

### Member constants

value [static] | true if `T` is a final class type , false otherwise (public static member constant)

### Member functions

operator bool | converts the object to bool, returns `value` (public member function)
operator() (C++14) | returns `value` (public member function)

### Member types

Type | Definition
`value_type` | `bool`
`type` | std::integral_constant <bool, value>

### Notes

Final classes cannot be used as base classes.

A union can be marked `final` (and `std::is_final` will detect that), even though unions cannot be used as bases in any case.

### Example

Run this code

    #include <iostream>
    #include <type_traits>

    class A {};
    class B final {};

    int main()
    {
        std::cout
            << std::boolalpha
            << std::is_final<A>::value << '\n'
            << std::is_final<B>::value << '\n';
    }

Output:

    false
    true

### See also

is_class (C++11) | checks if a type is a non-union class type (class template)
is_polymorphic (C++11) | checks if a type is a polymorphic class type (class template)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/types/is_final&oldid=98153"